#!/usr/bin/php
<?php

set_include_path('.:/opt/logserver/gui/');
require ('libs/config.php');
require ('libs/database.php');

$progname = 'export_filters.php';

function export_children($filtername, $selective = false)
{
	global $xml;
	global $selected;

	if ($selective && !count($selected))
		return;

	$children = Database::query("SELECT name, query FROM filters WHERE"
		. " parent_id = (SELECT id FROM filters WHERE name = '$filtername') ORDER BY name");

	foreach ($children as $child)
	{
		if ($selective)
		{
			$key = array_search($child['name'], $selected, true);
			if ($key === FALSE)
				continue;
			else
				unset($selected[$key]);
		}

		$xml .= '<filter name="' . htmlspecialchars($child['name'])
			. '" query="' . htmlspecialchars($child['query']) . '">';

		export_children($child['name'], $selective);

		$xml .= '</filter>';
	}
}

if ($argc < 2 || in_array($argv[1], array('--help', '-h')))
{
	echo "This script exports all filters to XML file\n";
	echo "Usage: $progname <filename> [filter ...]\n";
	echo "Notes:\n";
	echo "* if no filter is specified - all filters will be exported\n";
	echo "* if filter name contains spaces - enclose it in quotes\n";
	echo "* you must specify parent filters as well (except filter 'All')\n";
	exit(1);
}

$xml = '<?xml version="1.0" standalone="yes"?>'
	. '<op5-logserver><filters><filter name="All" query="">';

if ($argc == 2)
	export_children('All');
else
{
	$selected = array_slice($argv, 2);

	export_children('All', true);

	if (count($selected))
		echo "The following filters could not be exported: '"
			. implode("', '", $selected)
			. "'\nEither they don't exist or their parents were not specified\n";
}

$xml .= '</filter></filters></op5-logserver>';

if (@file_put_contents($argv[1], $xml) === FALSE)
{
	echo "Could not write to file {$argv[1]}\n";
	exit(1);
}
else
	exit(0);

?>
