#!/bin/bash

LSDB_HOME=$(dirname $0)

COMMAND=$1

$LSDB_HOME/configs/manage_pg_config.sh $COMMAND .i18n $LSDB_HOME/configs /var/lib/pgsql

case "$COMMAND" in
    'install')

	useradd op5lsu
	
	if [ ! -f "/var/lib/pgsql/data/PG_VERSION" ]
	then
    	    service postgresql initdb
	fi
	
	chkconfig postgresql on
    
	service postgresql start
	sleep 1
	
	echo -n "Creating database : "
	$2/create_database.sh >$2/db.create.log 2>&1 && echo "[  OK  ]" || echo "[FAILED]"
	;;
    'upgrade')
	service postgresql start
	sleep 1
	
	echo "Database upgrade start. Please wait"
	echo -n "Upgrading database : "
	$2/upgrade.sh >$2/db.update.log 2>&1 && echo "[  OK  ]" || echo "[FAILED]"
	;;
    'renew')
	;;
    
    'uninstall')
	service postgresql start
	if [ $(find /var/run -name "syslog-ng.pid") ];
	then
	    service syslog-ng stop
	    echo -n "Destroying database : "
	    $2/destroy_database.sh >$2/db.create.log 2>&1 && echo "[  OK  ]" || echo "[FAILED]"
	    service syslog-ng start
	else
	    echo -n "Destroying database : "
	    $2/destroy_database.sh >$2/db.create.log 2>&1 && echo "[  OK  ]" || echo "[FAILED]"
	fi
	
	userdel -r op5lsu
	;;
    
    *)
	echo "Bad parameter"
	;;
esac

$LSDB_HOME/configs/manage_pg_config.sh $COMMAND pg_hba.conf $LSDB_HOME/configs /var/lib/pgsql/data

service postgresql restart
