#!/bin/bash

if [ $# -ne 3 ]; then
	echo "Usage: load.sh <date> <time> <file>"
	exit
fi

if [ ! -e $3 ]; then
	echo "File $3 does not exist"
	exit
fi

messages=$(cat $3 | wc -l)

# drop caches
service postgresql stop
sync
echo 3 > /proc/sys/vm/drop_caches
service postgresql start

timestamp1=$(date +%s)
psql -U op5lsu op5lsu -t -c "SELECT load_to_table_function('$1', '$2', '$(pwd)/$3');"
timestamp2=$(date +%s)

let seconds=$timestamp2-$timestamp1
let mps=$messages/$seconds

printf "Messages  : %s\n" $messages
printf "Time, s   : %s\n" $seconds
printf "Speed, m/s: %s\n" $mps
