#!/bin/bash

if [ $# -ne 3 ]; then
	echo "Usage: load20.sh <date> <time> <file>"
	exit
fi

if [ ! -e $3 ]; then
	echo "File $3 does not exist"
	exit
fi

messages=$(cat $3 | wc -l)
total_messages=0
let total_messages=$messages*20
total_seconds=0
avg_seconds=0
min_seconds=10000
max_seconds=0
total_mps=0
avg_mps=0
min_mps=1000000
max_mps=0

for i in $(seq 20); do
	# drop caches
	service postgresql stop
	sync
	echo 3 > /proc/sys/vm/drop_caches
	service postgresql start

	timestamp1=$(date +%s)
	psql -U op5lsu op5lsu -t -c "SELECT load_to_table_function('$1', '$2', '$(pwd)/$3');"
	timestamp2=$(date +%s)

	let seconds=$timestamp2-$timestamp1
	let total_seconds=$total_seconds+$seconds
	if [ $seconds -lt $min_seconds ]; then min_seconds=$seconds; fi
	if [ $seconds -gt $max_seconds ]; then max_seconds=$seconds; fi

	let mps=$messages/$seconds
	let total_mps=$total_mps+$mps
	if [ $mps -lt $min_mps ]; then min_mps=$mps; fi
	if [ $mps -gt $max_mps ]; then max_mps=$mps; fi
done

let avg_seconds=$total_seconds/20
let avg_mps=$total_mps/20

printf "Messages  : %s\n" $total_messages
printf "Time, s   :\n"
printf "    total : %s\n" $total_seconds
printf "    avg   : %s\n" $avg_seconds
printf "    min   : %s\n" $min_seconds
printf "    max   : %s\n" $max_seconds
printf "Speed, m/s:\n"
printf "    avg   : %s\n" $avg_mps
printf "    min   : %s\n" $min_mps
printf "    max   : %s\n" $max_mps
