#!/bin/bash

if [ $# -ne 2 ]; then
	echo "Usage: search.sh <table> <query>"
	exit
fi

min=$(psql -U op5lsu op5lsu -t -c "SELECT id FROM messages_$1 ORDER BY id LIMIT 1")
max=$(psql -U op5lsu op5lsu -t -c "SELECT id FROM messages_$2 ORDER BY id DESC LIMIT 1")
let messages=$(echo $max)-$(echo $min)
# or
# messages=$(psql -U op5lsu op5lsu -t -c "SELECT COUNT(*) FROM messages_$1")

# drop caches
service postgresql stop
sync
echo 3 > /proc/sys/vm/drop_caches
service postgresql start

timestamp1=$(date +%s)
psql -U op5lsu op5lsu -t -c "SELECT * FROM messages_$1 WHERE $2;"
timestamp2=$(date +%s)

let seconds=$timestamp2-$timestamp1
let mps=$messages/$seconds

printf "Messages  : %s\n" $messages
printf "Time, s   : %s\n" $seconds
printf "Speed, m/s: %s\n" $mps
